/***************************************************************************
 * DIR.C - Directory functions                                             *
 * ---------------------------                                             *
 *                                                                         *
 * VCDID - CD-I filesystem driver                                          *
 * (c) 1997 - 1999 Vahur Sinijrv                                          *
 *                                                                         *
 * You are free to use any part of this source code, provided              *
 * that credit is given to author in such cases.                           *
 ***************************************************************************/

#include <basedef.h>
#include <vmm.h>
#include <error.h>
#include "vcdid.h"

#pragma VxD_PAGEABLE_CODE_SEG
#pragma VxD_PAGEABLE_DATA_SEG

DWORD _cdecl CDIFS_Dir( pioreq p )
{
    LPCDIFS_VOLUME l;
    DWORD          error;

    l = (LPCDIFS_VOLUME)p->ir_rh;
    switch( p->ir_flags ) {
    case CREATE_DIR:
    case DELETE_DIR:
            error = ERROR_WRITE_PROTECT;
            break;
    case QUERY83_DIR:
            error = ERROR_NOT_SUPPORTED;
            break;
    case QUERYLONG_DIR:
            error = NO_ERROR;
            break;
    case CHECK_DIR:
            error = FindDirRec( p->ir_rh, p->ir_ppath ) ? NO_ERROR :
                                                          ERROR_PATH_NOT_FOUND;
            break;
    }
    p->ir_error = error;
    return error;
}
