/***************************************************************************
 * DISKINF.C - Disc information functions                                  *
 *                                                                         *
 * VCDID - CD-I filesystem driver                                          *
 * (c) 1997 - 1999 Vahur Sinijrv                                          *
 *                                                                         *
 * You are free to use any part of this source code, provided              *
 * that credit is given to author in such cases.                           *
 ***************************************************************************/

#include <basedef.h>
#include <vmm.h>
#include <error.h>
#include "vcdid.h"

#pragma VxD_PAGEABLE_CODE_SEG
#pragma VxD_PAGEABLE_DATA_SEG

char CDIFS_NAME[] = "CDIFS";

DWORD _cdecl CDIFS_GetDiskInfo( pioreq p )
{
    LPCDIFS_VOLUME l;

    l = (LPCDIFS_VOLUME)p->ir_rh;

    p->ir_length  = COOKED_SECT_SIZE;
    p->ir_size    = l->size;
    p->ir_data    = NULL;
    p->ir_sectors = 16;
    p->ir_numfree = 0;
    p->ir_error   = 0;
    return 0;
}

DWORD _cdecl CDIFS_QueryResourceInfo( pioreq p )
{
    /*
     * Local FSDs should respond only to level 2 requests
     */
    if ( p->ir_options == 2 ) {

        if ( p->ir_length ) {

            /*
             * Copy filesystem name
             */
            if ( p->ir_length > sizeof( CDIFS_NAME ) )
                p->ir_length = sizeof( CDIFS_NAME );

            memcpy( p->ir_data, CDIFS_NAME, p->ir_length - 1 );
            ((char*)p->ir_data)[p->ir_length - 1] = 0;

            p->ir_options = FS_CASE_IS_PRESERVED |
                            FS_VOL_SUPPORTS_LONG_NAMES;
            p->ir_pos     = COOKED_SECT_SIZE;
            p->ir_length  = MAX_PATH-1 << 16 | MAX_PATH;
            p->ir_error   = NO_ERROR;
        } else
            p->ir_error = ERROR_INVALID_PARAMETER;
    } else
        p->ir_error = ERROR_INVALID_FUNCTION;

    return p->ir_error;
}
