/**********************************************************************
 * cdifsvxd.h
 *
 * Author:      Vahur Sinijrv
 * Description: Communication with CDIFS driver.
 *
 * (c) 1997 - 2000 Vahur Sinijrv
 *
 * You are free to use any part of this source code, provided
 * that credit is given to author in such cases.
 *
 *********************************************************************/

#ifndef CDIFSVXD_H
#define CDIFSVXD_H

#include "../Include/ioctl.h"
#include "../Include/cfg.h"

typedef enum
{
    IOC_GET_MOUNT_COUNT = 1,
    IOC_GET_MOUNTED_VOLUMES,
    IOC_GET_CONFIG,
    IOC_SET_CONFIG
} CDIFSVXD_IOC;

BOOL  cdifsvxd_init();
void  cdifsvxd_done();
DWORD cdifsvxd_getMountedCount();
DWORD cdifsvxd_getMounted( PIOCS_CDIFS_VOLUMES );
BOOL  cdifsvxd_getConfig( CDIFS_CONFIG* pConfig );
BOOL  cdifsvxd_setConfig( CDIFS_CONFIG* pConfig );

#endif