;Ϳ
;  IOSFN.ASM - IOS helper routines                              
;                                                               
;  VCDID - CD-I filesystem driver                               
;  (c) 1997 - 1999 Vahur Sinijrv                               
;                                                               
;  You are free to use any part of this source code, provided   
;  that credit is given to author in such cases.                
;
.486p

        INCLUDE vmm.inc
        MASM=1
        INCLUDE ilb.inc
        INCLUDE blockdev.inc
        INCLUDE ios.inc
        INCLUDE ior.inc
        INCLUDE iop.inc
        INCLUDE isp.inc
        INCLUDE vrp.inc
        INCLUDE dcb.inc
        INCLUDE srb.inc
        INCLUDE scsi.inc
        INCLUDE scsiport.inc

        INCLUDE async.inc
        INCLUDE vcdid.inc

        PUBLIC  _AllocIOP, _FreeIOP, _GetPhysDCB

VSD_REQ_SENSE_SIZE      EQU     0EH

VxD_CODE_SEG

;--------------------------------------------------------
; AllocIOP - Get an IOP from IOS
;
; IN    : tos + 4 - ptr to CDIFS_VOLUME
; OUT   : EAX     - ptr to IOR
; MODIFY: EAX
;--------------------------------------------------------
_AllocIOP       PROC
                push    ebp
                push    ebx
                push    ecx
                push    edx
                push    edi
                push    esi

                mov     eax, dword ptr [esp+6*4+4]
                sub     esp, size ISP_IOP_Create           ; Create temp struct
                mov     ebp, esp

                mov     edi, [eax].vi_vrp
                mov     bx, [edi].vrp_max_req_size
                mov     ax, [edi].vrp_max_sgd
                shl     ax, 3
                add     ax, bx
                mov     ebx, [edi].vrp_delta_to_ior
                mov     [ebp].ISP_IOP_size, ax
                mov     [ebp].ISP_delta_to_ior, ebx
                mov     [ebp].ISP_i_c_flags, ISP_M_FL_MUST_SUCCEED
                mov     [ebp].ISP_func, ISP_CREATE_IOP
                push    ebp
                call    [cdifs_ilb].ilb_service_rtn
                mov     esi, [ebp].ISP_IOP_ptr
                add     esp, size ISP_IOP_CREATE + 4       ; Discard isp

                mov     [esi+ebx].IOR_private_client, esi  ; Save IOP ptr
                add     esi, ebx                           ; Get to IOR

                ;
                ; Set ptr to scatter/gather descriptors
                ;
                mov     ebx, esi
                add     ebx, size IOR
                mov     [esi].IOR_sgd_lin_phys, ebx

                ;
                ; Fill out some default values
                ;
                mov     eax, dword ptr [esp+6*4+4]
                mov     bl, byte ptr [eax].vi_drive     ; get drive number from CDIFS_VOLUME
                mov     [esi].IOR_vol_designtr, bl      ; set drive number in IOR
;                mov     ebx, [eax].vi_media_handle      ; get media handle from CDIFS_VOLUME
                mov     ebx, [eax].vi_vrp
                mov     [esi].IOR_req_vol_handle, ebx   ; set media handle in IOR

                xor     eax, eax
                mov     [esi].IOR_next,           eax
                mov     [esi].IOR_xfer_count,     eax
                mov     [esi].IOR_start_addr + 4, eax
                mov     [esi].IOR_num_sgds,       al
                mov     [esi].IOR_flags,          IORF_VERSION_002 or \
                                                  IORF_BYPASS_VOLTRK or \
                                                  IORF_SYNC_COMMAND
                mov     eax, esi

                pop     esi
                pop     edi
                pop     edx
                pop     ecx
                pop     ebx
                pop     ebp
                ret
_AllocIOP       ENDP

;---------------------------------------------------
; GetDCB - Get Device Control Block
;
; IN:   tos+4  - drive number (byte)
; OUT:  eax    - offset to DCB for physical device
;---------------------------------------------------
_GetPhysDCB     PROC
                push    ebp
                push    ebx
                push    esi
                push    edi

                movzx   eax, byte ptr [esp+4*4+4]
                sub     esp, size ISP_DCB_GET
                mov     ebp, esp
                mov     [ebp].isp_func, ISP_GET_DCB
                mov     [ebp].isp_g_d_drive, eax
                push    ebp
                call    [cdifs_ilb].ilb_service_rtn
                mov     eax, [ebp + isp_g_d_dcb]
                or      eax, eax
                jz      @@out
                mov     eax, [eax].dcb_physical_dcb
@@out:
                add     esp, ISP_DCB_GET + 4

                pop     edi
                pop     esi
                pop     ebx
                pop     ebp
                ret
_GetPhysDCB     ENDP

;-------------------------------------------------------
; FreeIOP - frees IOP previosly allocated with AllocIOP
;
; IN :    tos+4 - ptr to IOR
; OUT:    None
; MODIFY: edx, ecx
;-------------------------------------------------------
_FreeIOP        PROC
                push    ebp
                push    eax
                push    esi
                push    edi
                push    ebx

                mov     eax, dword ptr [esp+5*4+4]      ; Get ptr to IOR

                sub     esp, size ISP_mem_dealloc
                mov     ebp, esp
                mov     eax, [eax].IOR_private_client
                mov     [ebp].isp_mem_ptr_da, eax
                mov     [ebp].isp_func, ISP_DEALLOC_MEM
                push    ebp
                call    [cdifs_ilb].ilb_service_rtn
                add     esp, size ISP_mem_dealloc + 4

                pop     ebx
                pop     edi
                pop     esi
                pop     eax
                pop     ebp
                ret
_FreeIOP        ENDP

VxD_CODE_ENDS

END
