;Ϳ
;  VCDID.ASM - VXD declaration & initialization                 
;                                                               
;  VCDID - CD-I filesystem driver                               
;  (c) 1997 - 2000 Vahur Sinijrv                               
;                                                               
;  You are free to use any part of this source code, provided   
;  that credit is given to author in such cases.                
;
.386p
        .xlist
        INCLUDE vmm.inc
        INCLUDE vwin32.inc
        INCLUDE winerror.inc

option casemap:notpublic

        MASM=1
        INCLUDE ifsmgr.inc
        INCLUDE ios.inc
        INCLUDE drp.inc
        INCLUDE vcache.inc

        INCLUDE vcdid.inc
        INCLUDE ioctl.inc
        INCLUDE async.inc
        .list

CDIFS_DEVICE_ID                 EQU     18ABH
CDIFS_DYNAMIC                   EQU     1

Create_VCDID_Service_Table      EQU     1

        PUBLIC  _g_CacheID

;-------------------------------------------------------------------
; CDIFS - CD-I file system VxD
;-------------------------------------------------------------------
Declare_Virtual_Device  CDIFS, 1, 0, VCDID_CONTROL, CDIFS_DEVICE_ID, \
                        UNDEFINED_INIT_ORDER, VCDID_VM, VCDID_PM
;                        cdifs_drp

;-----------------------------------
; Include service table declaration
;-----------------------------------
INCLUDE vcdid.inc

VxD_LOCKED_CODE_SEG

;-----------------------------------------------
; VxD Control procedure
;
; IN: eax - control id
;-----------------------------------------------
VCDID_CONTROL   PROC
                PUBLIC  VCDID_CONTROL
                cmp     eax, DEVICE_INIT
                jz      _DEVICE_INIT
                cmp     eax, INIT_COMPLETE
                jz      _INIT_COMPLETE
                cmp     eax, W32_DEVICEIOCONTROL
                jz      IO_CTRL
                clc
                ret
VCDID_CONTROL   ENDP

extern IO_Discard: near, int2f: near, _config_read: near

_DEVICE_INIT    PROC
                PUBLIC  _DEVICE_INIT

                clc
                ret
_DEVICE_INIT    ENDP

_INIT_COMPLETE  PROC
                mov     edx, OFFSET32 msg_logo
                call    Print

                VxDCall IFSMGR_Get_Version
                jc      @@fail

                VxDCall IOS_Get_Version
                jc      @@fail

                VxDCall VCache_Get_Version              ; Cache ain't strictly needed
                jc      @@fail

                ;
                ; Register with IFSMGR
                ;
                VxDCall IFSMGR_RegisterMount <OFFSET32 CDIFS_MountVolume, IFSMGRVERSION, 0>
                cmp     eax, -1
                jz      @@fail

                ;
                ; Register with input-output supervisor (IOS)
                ;
                mov     [cdifs_drp].DRP_AER, OFFSET32 async_evr
                mov     [cdifs_drp].DRP_ILB, OFFSET32 cdifs_ilb
                push    OFFSET32 cdifs_drp
                VxDCall IOS_Register
                add     esp, 4
                mov     ax, [cdifs_drp].DRP_reg_result
                cmp     ax, DRP_REMAIN_RESIDENT
                jz      @@IOSSuccess
                cmp     ax, DRP_MINIMIZE
                jnz     @@fail
@@IOSSuccess:
                mov     esi, OFFSET32 IO_Discard
                mov     ecx, NUM_CACHE_BLOCKS
                VxDCall VCache_Register
                mov     _g_CacheID, al

                ;
                ; Hook int2f - ain't strictly necessary
                ;
                mov     eax, 2fh
                mov     esi, OFFSET32 int2f
                VMMCall Hook_V86_Int_Chain

                ;
                ; Read configuration from registry
                ;
                call    _config_read

                clc
                ret
@@fail:
                mov     edx, OFFSET32 msg_fail
                call    Print
                stc
@@end:
                ret
_INIT_COMPLETE  ENDP

Print           PROC
                mov     ah, 9
                push    21h
                VMMCall Exec_VxD_Int
                ret
Print           ENDP

VCDID_VM        PROC
                ret
VCDID_VM        ENDP

VCDID_PM        PROC
                ret
VCDID_PM        ENDP

;--------------------------------------------
; Handle DeviceIoControl requests
;
; IN: ECX - function id
;     EBX - dwDDB
;     EDX - hDevice
;     ESI - lpDIOCParams
;--------------------------------------------
IO_CTRL         PROC
                cmp     ecx, DIOC_OPEN
                jnz     @@1
                xor     eax, eax
                ret
@@1:
                cmp     ecx, DIOC_CLOSEHANDLE
                jnz     @@2
                xor     eax, eax
                ret
@@2:
                dec     ecx
                cmp     ecx, MAX_IOC
                jae     @@error

                push    esi
                call    [iocfunc + ecx*4]
                stc
                ret
@@error:
                mov     eax, ERROR_NOT_SUPPORTED
                clc
                ret
IO_CTRL         ENDP

VxD_LOCKED_CODE_ENDS


VxD_LOCKED_DATA_SEG

iocfunc         dd      IOC_GET_MOUNT_COUNT
                dd      IOC_GET_MOUNTED_VOLUMES
                dd      IOC_GET_CONFIG
                dd      IOC_SET_CONFIG

MAX_IOC         equ     ($ - iocfunc) / 4

msg_logo        db      0dh, 0ah, '-=[ CD-I Filesystem Driver ver. 2.0 BETA by Vahur Sinijrv (c) 1997-2000 ]=-', 0dh, 0ah, '$'
msg_fail        db      'CDIFS: cannot initialize', 0dh, 0ah,'$'

VxD_LOCKED_DATA_ENDS

VxD_DATA_SEG
_g_CacheID      db      ?
VxD_DATA_ENDS

VxD_REAL_INIT_SEG
BeginProc       RealInit
                xor     bx, bx
                xor     si, si
                xor     edi, edi
                mov     ax, DEVICE_LOAD_OK
                ret
EndProc         RealInit
VxD_REAL_INIT_ENDS

END RealInit
